require ("math")
require 'love.image'
 
 
 
 --[[
 code learned from :
 http://rosettacode.org/wiki/Draw_a_sphere
  ]]
 
shades = {'.', ':', '!', '*', 'o', 'e', '&', '#', '%', '@'}
 
function normalize (vec)
    len = math.sqrt(vec[1]^2 + vec[2]^2 + vec[3]^2)
    return {vec[1]/len, vec[2]/len, vec[3]/len}
end
 
--light = normalize{30, 30, -50}
light = normalize{0, 0, -10}
 
function dot (vec1, vec2)
    d = vec1[1]*vec2[1] + vec1[2]*vec2[2] + vec1[3]*vec2[3]
    return d < 0 and -d or 0
end
 
function fill(x,y,r,g,b,a)
  r = 0 g = 0 b = 0 a = 0
  return r,g,b,a
end

 
 imageSD = love.image.newImageData(20,20)
 imageSD:mapPixel(fill)
 
 Xi2 = 0
 Yi2 = 0
 
 
function draw_sphere (radius, k, ambient, r,g,b,a)
    
    --k = 4
    --ambient = 0.1
    
    local ra,ga,ba
    local xi,yi xi=0 yi=0 
    imageSD = love.image.newImageData(2*radius+1,2*radius+1)
    imageSD:mapPixel(fill)
    
    for i = math.floor(-1*radius),-math.floor(-1*radius) do
        x = i + 0 --.25       
        --local line = ''
        for j = math.floor(-1*radius),-math.floor(-1*radius) do
            --y = j / 2 + .5    
            y = j  + 0 --0.5    
            if x^2 + y^2 <= radius^2 then
                vec = normalize{x, y, math.sqrt(radius^2 - x^2 - y^2)}
                b = dot(light,vec) ^ k + ambient
                --intensity = math.floor ((1 - b) * #shades)
                --line = line .. (shades[intensity] or shades[1])
                int = b  -- math.floor ((1 - b) * 127) + 128
                ra=r*int  ga=g*int ba=b*int 
                imageSD:setPixel(xi,yi,ra,ga,ba,a)
                
--                r,g,b,a = imageD2:getPixel(Xi2+xi, Yi2+yi)
--                ra=r*int  ga=g*int ba=b*int 
--                imageD2:setPixel(Xi2+xi,Yi2+yi,ra,ga,ba,a)
                
                
            else
              
--                r,g,b,a = imageD2:getPixel(Xi2+xi, Yi2+yi)
--                ra=r  ga=g ba=b 
--                imageD2:setPixel(Xi2+xi,Yi2+yi,ra,ga,ba,a)
                
                --line = line .. ' '
                --ra=0  ga=0 ba=0 
                --imageSD:setPixel(xi,yi,ra,ga,ba,0)
                --print(xi.." "..yi.." "..i.." "..j)
                --print(i.." "..j)
            end
            yi=yi+1            
        end
        xi=xi+1  yi = 0
        --print (line)
    end
end
 
--draw_sphere (20, 4, 0.1)
--draw_sphere (10, 2, 0.4)