require 'love.timer'
require 'love.image'
require 'love.filesystem'

require 'TSerial'
require 'complex'
require 'sphere'
require 'colorTab'

im = love.image
tm = love.timer
tr = love.thread

tr	= love.thread.getThread()


--Trm1 = love.thread.newThread('Trm11','mandelfun.lua')
--Trm2 = love.thread.newThread('Trm11','mandelfun.lua')
--Trm3 = love.thread.newThread('Trm11','mandelfun.lua')
--Trm4 = love.thread.newThread('Trm11','mandelfun.lua')
--Trm1:start()
--Trm2:start()
--Trm3:start()
--Trm4:start()





function showBox()
    -- let's for old mode
--    str1 = "{"..Bmx1..","..Bmx2..","..Bmy1..","..Bmy2.."},"
--    print(str1)
--    str1 = "{"..Mxc..","..Myc..","..Mrd.." },"
--    print(str1)
end


function fillImage(x,y,r,g,b,a)
  r = 200 g = 200 b = 200 a = 200
  return r,g,b,a
end

tabSize={
  { 100,  100},--1
  { 200,  150},--2
  { 300,  300},--3
  { 400,  300},--4
  { 500,  500},--5
  { 600,  600},--6
  { 700,  700},--7
  { 800,  600},--8
  {1000, 1000},--9
  {1200, 1200},--10
  {1280, 1024},--11
  {1618, 1000},--12
  {2000, 2000},--13
  {3000, 3000},--14
}
SizeX=10 SizeY=10
function setSize(n)
  if tabSize[n]== nil then
    SizeX=tabSize[1][1]    SizeY=tabSize[1][2]
  else      
    SizeX=tabSize[n][1]    SizeY=tabSize[n][2]
  end
  imageD = im.newImageData(SizeX,SizeY)
  imageDBase = im.newImageData(SizeX,SizeY)
  imageD:mapPixel(fillImage)
  tr:set('id2rK',imageD) -- pass reference
  tr:set('id2rK1',imageDBase)
  
  --print("qui")
  
end

setSize(4)





buildColorsTab()


C2tab={}  
C2max = 0



Pts={}
Idx = 1


local Z , C
local cx

function f1a(zr,zi,cr,ci) -- z = z^2+c
    z = complex.new(zr,zi)
    c = complex.new(cr,ci)
    z = complex.mul(z,z)
    z = complex.add(z,c)
    return z
end


function f1a(r,i)
    local n,dist,z
    C = complex.new(r,i)
    Z = complex.new(0,0)
    z = complex.new(0,0)
    dist = 0
    n = 0
    while dist < 4 and n < MAXITER do
      z.r = Z.r*Z.r - Z.i*Z.i 
      z.i = Z.r*Z.i + Z.r*Z.i 
      Z.r = z.r + C.r
      Z.i = z.i + C.i
      dist = Z.r*Z.r + Z.i*Z.i
      n = n+1
    end
    return n 
end









Cr = -0.624  
Ci =  0.435 

function f1b(r,i) -- see if it is julia
    local n,dist,z
    
    C = complex.new(Cr,Ci)
    Z = complex.new(r,i)
    z = complex.new(0,0)
    dist = 0
    n = 0
    while dist < 4 and n < MAXITER do
      z.r = Z.r*Z.r - Z.i*Z.i 
      z.i = Z.r*Z.i + Z.r*Z.i 
      Z.r = z.r + C.r
      Z.i = z.i + C.i
      dist = Z.r*Z.r + Z.i*Z.i -- appartiene a mandelbrot se dist^2 < escapeValue(suppose 4)
      n = n+1
    end
    
    --[[  --http://linas.org/art-gallery/escape/escape.html
      Z = Z*Z +C; iter_count ++;    // a couple of extra iterations helps
      Z = Z*Z +C; iter_count ++;    // decrease the size of the error term.
      float modulus = sqrt (ReZ*ReZ + ImZ*ImZ);
      float mu = iter_count - (log (log (modulus)))/ log (2.0);
      color_value = colormap_lookup (mu);
      draw_pixel (C, color_value);    
      -----------------------------------------------------
      z = z * z + C; iteration++;
      z = z * z + C; iteration++;
      double mu = iteration - (Math.Log(Math.Log(z.Modulus))) / logEscapeRadius;
      colorIndex = (int)(mu / maxIteration * 768);
      if (colorIndex >= 768) colorIndex = 0;
      if (colorIndex < 0) colorIndex = 0;
    ]]    
    
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx  
--    cx = complex.mul(z,z) cx = complex.add(cx,c)  z = cx
--    n=n+2
--    modulus = math.sqrt(z.r*z.r+z.i*z.i)
--    local mu = n - (math.log (math.log(modulus)))/(math.log(2))
--    n1 = math.floor(mu)
--    if n1 < 0 then n1=0 end
--    if n1 > MAXITER then n1 = MAXITER end
    
    return n 
    
end





redo = false

Mxc = 0  Myc = 0  Mrd = 0

live = 0

 local idxc = 0
 
local MAXITER_prepare = MAXITER

while true do
  
  live = (live + 1)%1000
  tr:set('live',live)
--  print (live)
  
  
  if tr:get('c2') or redo then
    
    MAXITER = MAXITER_prepare
    
    tr:set('id2r',imageD) -- pass reference
    
    tm1 = love.timer.getMicroTime()
    
    local dxr,dyr,n2,x,y,iw,ih
    local r,g,b,a,c,v
    local r,i
    local idx
    
    n2 = 1
    tr:set('nn2',n2)
    
    
    iw = imageD:getWidth()  
    ih = imageD:getHeight() 
    
    ------ old system --------  
    --mx1a = tr:get('mx1',mx1)    mx2a = tr:get('mx2',mx2) 
    --my1 = tr:get('my1',my1)    my2 = tr:get('my2',my2) 
    
    ------------------- change xxratio
    --    local xc,dxm,ratio
    --    ratio = iw/ih
    --    dxm = math.abs(mx1a-mx2a)/2
    --    xc = mx1a+dxm
    --    mx1 = xc - dxm * ratio
    --    mx2 = xc + dxm * ratio
    ----------------------------------
    
    
    ---------------------- new system --------------
    -- need only mx1,dxr my1,dyr
    Mxc = tr:get('Mxc')
    Myc = tr:get('Myc')
    Mrd = tr:get('Mrd')
    
    ------------------------ for julia
    Cr = Mxc Ci = Myc
    ------------------------------------
    
    
    local rmin,rtx,rty
    rmin = math.min(iw,ih)
    rtx = iw/rmin  -- 1 or 1,xxx
    rty = ih/rmin   -- 1 or 1,xxx
    
    dxr = Mrd * rtx
    dyr = Mrd * rty
    
    ----------------------------------
    Bmx1 = Mxc - dxr
    Bmy1 = Myc - dyr
    
    Bmx2 = Mxc + dxr
    Bmy2 = Myc + dyr
    
    showBox()
    ----------------------------------
    
    Pts[1]=iw
    Pts[2]=ih
    Idx = 3
    
    for i=0,MAXITER do C2tab[i] = 0 end  -- clear istogram
    
    local toggleX = 0
    local toggleY = 0
    
    ------------------------------  build image -----------------------------
    
    ---------------------------------------------------------------
    function calcola(x,y)
      
        if x < 0 or y < 0 or x >= iw  or y >= ih  then return end
      
        r = Bmx1 + 2*dxr * (x / iw) 
        i = Bmy1 + 2*dyr * (y / ih)
        
        v = f1a(r,i) -- mandelbrot (f1b x julia)
        
        if(v >= MAXITER) then  v = 0 end
        
        
        if(v > 0) and (v < MAXITER) then  -- don't update at 0 and  MAXITER
          C2tab[v] = C2tab[v]+1 
        end 
        
        idxc = math.floor(NumColors * (v/MAXITER))
        
        r,g,b,a = gettabColor(idxc)
        
        imageD:setPixel(x,y,r,g,b,a)
       
        ------------- 16 bit escap numbers stored in r,g,b
        g = math.floor(v / 256)
        b = math.floor(v - (g * 256))
        imageDBase:setPixel(x,y,0,g,b,255)
        ----------------------------------------
        
        n2 = n2+1
        if (n2 % 100)==0 then
          tr:set('nn2',n2)
          tr:set('id2rK',imageD)
          tr:set('id2rK1',imageDBase)
        end
        
    end    
    ------------------------------------------- end calcola -------
    
    
    ---------------------------------------------
    -- circular fill from center image
    ---------------------------------------------
    local nxc = iw/2
    local nyc = ih/2
    local nm = math.max(iw/2,ih/2)
    local nc,nc2,xa,ya,n
    
    for nc=0,nm do
      
      if tr:get('stop') then  break  end
      
      nc2 = nc * 2
      
      xa = nxc - nc   ya = nyc - nc
      for n=0, nc2 do  calcola(xa,ya)  xa=xa+1   end
      
      xa = nxc + nc   ya = nyc - nc
      for n=0, nc2 do  calcola(xa,ya)  ya=ya+1   end
      
      xa = nxc + nc   ya = nyc + nc
      for n=0, nc2 do  calcola(xa,ya)  xa=xa-1   end
      
      xa = nxc - nc   ya = nyc + nc
      for n=0, nc2 do  calcola(xa,ya)  ya=ya-1   end
      
    end
    ---------------------------------------------
    
    t1 = love.timer.getMicroTime() - tm1
    
    local str = TSerial.pack(C2tab)
    tr:set('C2tabStr',str)
    tr:set('id2r',imageD)
    tr:set('done2',true)
    
  end
  
  
  if tr:get('saveData') then
    print("saving data...")
    local str1 = "IMG_"..os.time()..".png"
    imageD:encode(str1)
    print("saved.")
  end  
  
  
  if tr:peek('size') then 
    local n = tr:get('size') 
    setSize(n)
  end
  
  
  if tr:get('buildCT') then
    if tr:peek('cfreq') then  Freq = tr:get('cfreq') end
    if tr:peek('cstart') then  StartColor = tr:get('cstart') end
    if tr:peek('cLum') then  Luminosity = tr:get('cLum') end
    if tr:peek('cContr') then  Contrast = tr:get('cContr') end
    buildColorsTab()
  end
  
  
  if tr:peek('maxiter') then
    MAXITER_prepare = tr:get('maxiter')  
  end
  
  
--  if tr:peek('oneColor') then
--    oneColor = tr:get('oneColor')
--    buildColorsTab()
--  end
  
  
end

    