
MAXITER = 768

NumColors = 768

--hue = 180

FreqMin = -10
FreqMax = 50
FreqColor = 18.1
local deltaFreq = math.abs(FreqMax-FreqMin) 
Freq = 100*(FreqColor/deltaFreq)


StartColor = 10
Hue = 60
Luminosity = 100
Contrast = 100

LastFreq = 0
LastStart = 0

LastHue = 180
LastLum = 100
LastCont = 100

Huer = 100
Hueg = 150
Hueb = 200


dwCnt = 0
upCnt = 0
idxStart = 0

oneColor = false

tabColor = {}

function gettabColor(idxc)
  local r,g,b,a,i
  
  i = (idxc + idxStart) % (#tabColor+1)
  
  r=tabColor[i][1] 
  g=tabColor[i][2] 
  b=tabColor[i][3] 
  a=tabColor[i][4]
  
  return r,g,b,a
end

pass = 0

function buildColorsTab()
  
  colorLimit()
  
  pass = pass +1 
  --print("qui3 "..pass)
  
  --print(FreqColor)
  --print (StartColor)
  
  tabColor = {}
  local v,x,r,g,b,a,c,cn,F 
  
  F = FreqColor
  
  a=255
  
  for x=0,NumColors do
    v = x/NumColors -- v->0..1
    
--    if oneColor then
--      
--      r,g,b = hue2rgb()
--    
--    else
      --    r = 128 + 127 * math.sin(3*math.pi/2 + 2*math.pi*F * v)
      --    g = 128 + 127 * math.sin(2*math.pi/2 + 2*math.pi*F * v)
      --    b = 128 + 127 * math.sin(1*math.pi/2 + 2*math.pi*F * v)
      r = 128 + 127 * math.sin((45+290)/180*math.pi + 2*math.pi*F * v)
      g = 128 + 127 * math.sin((45+120)/180*math.pi + 2*math.pi*F*1.5 * v)
      b = 128 + 127 * math.sin((45+ 73)/189*math.pi + 2*math.pi*F*2.7 * v)    
      --    r = 128 + 127 * math.sin((StartColor   +  0)/180*math.pi + 2*math.pi*F* v)
      --    g = 128 + 127 * math.sin((StartColor   +120)/180*math.pi + 2*math.pi*F* v)
      --    b = 128 + 127 * math.sin((StartColor   +240)/189*math.pi + 2*math.pi*F* v)    
--    end
    
    tabColor[x]={r,g,b,a}
    
    idxStart = math.floor((#tabColor * (StartColor/100)) % (#tabColor+1))    
    
  end
  
--  local idx
--  idx = math.floor((#tabColorL * (StartColor/100)) % (#tabColorL+1))
--  for x=0,NumColors do
--    tabColor[idx] = tabColorL[idx]
--    idx = (idx+1) % (#tabColorL+1)
--  end
  
  
  --tabColor[MAXITER]={0,0,0,0}
end

tabColorL = {}
function buildColorsTabL()
  tabColorL = {}
  local x,r,g,b,n,a,c,cn
  for x=0,NumColors do
    if x < 256 then b = x 
    elseif x < 512 then b=255 g = x - 256 
    elseif x < 768 then b=255 g=255 r = x - 512
    else b=255 g=255 r = 255 end
    tabColorL[x]={r,g,b,a}
  end
end



function colorLimit()
  
  
--  if oneColor then
--    FreqMin = 0
--    FreqMax = 360
--    deltaFreq = math.abs(FreqMax-FreqMin) 
--    FreqColor = FreqMin +  deltaFreq * (Freq/100)
--  else
--    FreqMin = -10
--    FreqMax = 50
--    deltaFreq = math.abs(FreqMax-FreqMin) 
--    FreqColor = FreqMin +  deltaFreq * (Freq/100)
--  end
  
  FreqColor = FreqMin +  deltaFreq * (Freq/100)
  --hue = 360 * (Freq/100)
  
end


function hue2rgb(hue)
  local r,g,b 
  local v1,v2,v3
  -------------------------------------- hue - sp1
  v1 = hue -- -> 0..360
  v2 = (v1 % 60) 
  v3 = math.floor(v1/60)
  r=0 g=0 b=0 
  if     v3==0 or v3==6 then  r = 255     g = 255 * (0+v2/60)
  elseif v3==1 then  r = 255*(1-v2/60)    g = 255
  elseif v3==2 then  g = 255              b = 255 * (0+v2/60)
  elseif v3==3 then  g = 255*(1-v2/60)    b = 255             
  elseif v3==4 then  b = 255              r = 255 * (0+v2/60)
  elseif v3==5 then  b = 255*(1-v2/60)    r = 255              
  end
  -------------------------------------------
  
  -------------------------------------------
  --  intensity (v of hsv)
  v = Luminosity/100
  r = math.ceil(r*v)    g=math.ceil(g*v)   b=math.ceil(b*v)
  -------------------------------------------
  
  -------------------------------------------
  -- sat  (the s of hsv)
  v = Contrast/100
  local m
  m = math.max(r,g)
  m = math.max(m,b)
  r = r + ((m-r) * (1-v))
  g = g + ((m-g) * (1-v))
  b = b + ((m-b) * (1-v))
  -------------------------------------------
  
  
  return r,g,b
end
