gr = love.graphics

local rd = 8
local k = 16

------------------------------------------
--local currButton = false
--local prevButton = false
--function klikL()
--  local flag
--  prevButton = currButton
--  currButton = love.mouse.isDown("l")
--  --print(tostring(prevButton).."  "..tostring(currButton))
--  if prevButton == currButton then flag = false end
--  if prevButton ~= currButton then flag = true  end
--  return flag, currButton
--end
------------------------------------------

--==============================================================
local checkIDstate={}
local checkGrab = false

function checkSet(id, boolean)
  checkIDstate[id] = boolean
end  
  
function checkToggle(id, row, col, checkMode)
  
  local sx,sy
  sx = col * k
  sy = row * k
  
  local currState
  
  local r,g,b,a
  local x,y,d
  local cx,cy
  
  cx = sx + rd
  cy = sy + rd
  
  r,g,b,a = gr.getColor()  
  
  x,y = love.mouse.getPosition()
  
  --x,y = MouseXlbi,MouseYlbi
  
  d = math.sqrt((x-cx)^2 + (y-cy)^2)
    
  if checkIDstate[id] ~= true then    checkIDstate[id]= false end
  currState = checkIDstate[id]
    
  -- show if into position
  if d < rd then  
    gr.setColor(230,000,000,200)  
  else
    gr.setColor(200,200,200,200)  
  end
  gr.circle("line",cx,cy,rd-1)
    
  -- look if must toggle
  if d < rd  then  
    if(love.mouse.isDown("l")) then
    --if klikL()  then
      if checkGrab == false then
        checkGrab=true
        if checkIDstate[id]==false then
          --f=true 
          checkIDstate[id]=true  
        else
          --f=false 
          checkIDstate[id]=false  
        end
      end
    else
      
      if checkMode == true then
        checkGrab=false -- chekck
      else -- is push button mode
        if checkGrab == true then --button
          checkGrab=false
          checkIDstate[id]=false  
        end
      end
    end
  else
    if checkMode ~= true then -- button mode-> off if outside
      checkIDstate[id]=false  
      --checkGrab = false
    end
  end

  -- look true/false
  if checkIDstate[id]~=true then
    gr.setColor(r,g,b,200)  
    gr.circle("fill",cx,cy,rd-4)
  else
    gr.setColor(100,250,100,200)  
    gr.circle("fill",cx,cy,rd-4)
  end
  
  gr.setColor(r,g,b,a)  
  
  local changeFlag
  changeFlag = currState ~= checkIDstate[id]
  
  return checkIDstate[id], changeFlag
  
end
--==============================================================











--==============================================================
local sliderGrab = false
local sliderID = 0
function slider(id, sx,sy,lx,ly,p)
  
--  local sx,sy,lx,ly
--  sx = col*k
--  sy = row*k
--  lx = Ncol*k
--  ly = Nrow*k
  
  
  local r,g,b,a
  r,g,b,a = gr.getColor()
  
  gr.setColor(100,100,100,155)  
  gr.rectangle("fill",sx+2,sy+2,lx-4,ly-4)
  
  local x,y,d
  d = p * lx
  x,y = love.mouse.getPosition()
  if (x>=sx) and (x<=(sx+lx)) and (y>=sy) and (y<=(sy+ly)) and sliderGrab==false then  
    gr.setColor(200,0,0,255)
    if(love.mouse.isDown("l")) then
      sliderID = id
      sliderGrab = true
      d = x - sx  
      p = d / lx
    end      
  else
    if sliderGrab == true and id == sliderID then
      if(not love.mouse.isDown("l")) then
        sliderGrab = false
      end
      if (x>=sx) and (x<=(sx+lx)) then  
        gr.setColor(200,0,0,255)
        d = x - sx  
        p = d / lx
      end
    end
  end
  
  --gr.line(sx,sy+ly/2,sx+lx,sy+ly/2)
  
  gr.setColor(200,200,200,255)    
  gr.line(sx+d,sy+1, sx+d,sy+ly-1)
  
  gr.setColor(250,250,250,255)    
  gr.line(sx+lx/2,sy+1, sx+lx/2,sy+2)
  
--  gr.line(sx+1/3*lx,sy, sx+1/3*lx,sy+1)
--  gr.line(sx+2/3*lx,sy, sx+2/3*lx,sy+1)
  
  gr.setColor(r,g,b,a)
  return p
end

function sliderV(id, sx,sy,lx,ly,p)
  
  
  local r,g,b,a
  r,g,b,a = gr.getColor()
  
  gr.setColor(100,100,100,155)  
  gr.rectangle("fill",sx,sy,lx,ly)
  
  local x,y,d
  d = p * ly
  x,y = love.mouse.getPosition()
  if (x>=sx) and (x<=(sx+lx)) and (y>=sy) and (y<=(sy+ly)) and sliderGrab==false then  
    gr.setColor(200,0,0,255)
    if(love.mouse.isDown("l")) then
      sliderID = id
      sliderGrab = true
      d = y - sy  
      p = d / ly
    end      
  else
    if sliderGrab == true then
      if(not love.mouse.isDown("l")) then
        sliderGrab = false
      end
      if (y>=sy) and (y<=(sy+ly)) and id == sliderID  then  
        gr.setColor(200,0,0,255)
        d = y - sy  
        p = d / ly
      end
    end
  end
  gr.line(sx+lx/2,sy,sx+lx/2,sy+ly)
  gr.setColor(200,200,200,255)    
  gr.line(sx,sy+d, sx+lx,sy+d)
  
  gr.setColor(250,250,250,255)    
  gr.line(sx,sy+ly/2, sx+1,sy+ly/2)
  
  gr.setColor(r,g,b,a)
  return p
end
--==============================================================


function gridRCk(k)
  local xm,ym,x,y,m,r,g,b,a,w
  r,g,b,a = gr.getColor()
  gr.setColor(120,120,120,200)
  m = gr.getLineStyle()
  gr.getLineStyle('rough')
  w = gr.getLineWidth(0.5)
  
  if k<8 then k=8 end
  xm = gr.getWidth()   ym = gr.getHeight()
  for x=0,xm,k do 
    if (x%(10*k))==0 then
      gr.setColor(220,220,220,200)
    else
      gr.setColor(120,120,120,200)
    end
    gr.line(x,0,x,10) 
    gr.line(x,ym-10,x,ym) 
  end
  for y=0,ym,k do 
    if (y%(10*k))==0 then
      gr.setColor(220,220,220,200)
    else
      gr.setColor(120,120,120,200)
    end
    gr.line(0,y,10,y) 
    gr.line(xm-10,y,xm,y) 
  end
  gr.getLineStyle(m)
  gr.setColor(r,g,b,a)
  gr.setLineWidth(w)
end

